package com.belkast.soap;

import com.beust.jcommander.ParameterException;
import com.beust.jcommander.*;

import javax.crypto.BadPaddingException;
import java.io.File;
import java.net.HttpURLConnection;
import java.text.SimpleDateFormat;
import java.util.*;

public class webService {
    static Date dateStart = new Date();
    static SimpleDateFormat varFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    static Boolean varDebug = false;
    static String varKey;
    static String varSalt = "1zcHJvdG9ubWFpbC9icmlkZ2UtdjMvdXNlcnMvYnJpZGdlLXZhdWx0LWtleQl0gx";

    public static void main(String... argv) throws Exception {

//        @Parameter(names = "--props",
//          description = "Location of the Properties file")

//        @Parameter(names = "--key",
//          description = "Encryption Key (length of 16)")

//        @Parameter(names = "--encrypt",
//          description = "Encrypt this value using the Key")

//        @Parameter(names = "--debug",
//          description = "Write details to the screen")

        jCommanderArgs args = new jCommanderArgs();
        JCommander jct = new JCommander(args);

        try {
            jct.parse(argv);
        } catch (ParameterException ex) {
            System.out.println();
            jct.usage();
            System.exit(0);
        }

        System.out.println();

        varDebug = Boolean.valueOf(args.debug);
        varKey = args.key;
        String varToEncrypt = args.encrypt;

        if (varToEncrypt != null && !varToEncrypt.isEmpty())
        {
            String varToStore = salter.encrypt(varToEncrypt, varKey, varSalt);
            String varChecked = salter.decrypt(varToStore, varKey, varSalt);

            System.out.println("Clear Text Password : " + varToEncrypt);
            System.out.println("Encryption Key      : " + varKey);
            System.out.println("Encrypted / Encoded : " + varToStore);
            System.out.println("Decoded / Decrypted : " + varChecked);
            System.out.println();
            System.exit(0);
        }

        String varProps = args.props;
        if (varProps == null && varToEncrypt == null)
        {
            debugProcessor.writer(true, "Check the program parameters. There is nothing to do!");
            System.out.println();
            jct.usage();
            System.exit(0);
        }

        if (!fileProcessor.getFile(varProps) || !fileProcessor.validFile(varProps))
        {
            debugProcessor.writer(true, "Something went wrong. Please check that the properties file is correctly formatted!");
            System.exit(0);
        }

        if (varProps != null)
        {
            doSoap(new File(varProps));
        }

        System.exit(0);
    }

    private static void doSoap(File thisProps) throws Exception {
        String varPassword = "";
        debugProcessor.writer(false, "Debug is set to : " + varDebug);

        String varURL = propertyProcessor.getProperty(thisProps, "SHIM_URL");
        String varUsername = propertyProcessor.getProperty(thisProps, "USERNAME");
        String varPasswordTemp = propertyProcessor.getProperty(thisProps, "PASSWORD");

        String varUseSSL = propertyProcessor.getProperty(thisProps, "SSL");
        String varKeystore_LOC = propertyProcessor.getProperty(thisProps, "JAVA_KS_LOCATION");
        String varKeystore_PW = propertyProcessor.getProperty(thisProps, "JAVA_KS_PASSWORD");

        String varInputFile = propertyProcessor.getProperty(thisProps, "XML_FILE");

        String varRoleFile = propertyProcessor.getProperty(thisProps, "CSV_FILE");
        String varPropEmptyColumns = propertyProcessor.getProperty(thisProps, "CSV_ALLOW_EMPTY_COLUMN_VALUES");
        Boolean varEmptyColumns = Boolean.valueOf(varPropEmptyColumns);

        try {
            File checkInput = new File(varInputFile);
            if (!checkInput.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in XML_FILE does not exist [ " + varInputFile + " ]");
                System.exit(0);
            }

            File checkRole = new File(varRoleFile);
            if (!checkRole.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in CSV_FILE does not exist [ " + varRoleFile + " ]");
                System.exit(0);
            }
        }
        catch (Exception e)
        {
            debugProcessor.writer(true, thisProps + " => Something went wrong. Please check that the properties file is correctly formatted!");
            System.exit(0);
        }

        try {
            varPassword = salter.decrypt(varPasswordTemp, varKey, varSalt);

        } catch (Exception e) {
            debugProcessor.writer(true, "The password could not be decrypted. Please check that the Encryption Key is correct!");
            System.exit(0);
        }

        System.out.println();
        debugProcessor.writer(varDebug, thisProps + " => SOAP URL : " + varURL);
        debugProcessor.writer(varDebug, thisProps + " => Username : " + varUsername);
        debugProcessor.writer(varDebug, thisProps + " => Use SSL : " + varUseSSL);
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore : " + varKeystore_LOC);
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore password : " + varKeystore_PW);
        debugProcessor.writer(varDebug, thisProps + " => XML file : " + varInputFile);
        debugProcessor.writer(varDebug, thisProps + " => CSV file : " + varRoleFile);
        debugProcessor.writer(varDebug, thisProps + " => CSV allow empty : " + varEmptyColumns);

        ArrayList thisCSV = userVerify.readCSV(varRoleFile, false, !varEmptyColumns);

        boolean validfile = (!thisCSV.isEmpty());
        debugProcessor.writer(true, varRoleFile + " => CSV file is valid   : " + validfile);
        debugProcessor.writer(true, varRoleFile + " => records to process  : " + thisCSV.size());

        if (!validfile)
        {
            debugProcessor.writer(true, varRoleFile + " => verification failed : please verify the file with com.belkast.soap.userVerify!");
        }
        int varCount = 0;
        Iterator<Map> mapper1 = thisCSV.iterator();
        while (mapper1.hasNext()) {
            varCount++;
            debugProcessor.writer(false, "");
            debugProcessor.writer(true, "processing record " + varCount);

            Map hashMap = mapper1.next();
            debugProcessor.writer(varDebug, "record " + varCount + " : " + hashMap.values().toString());

            Iterator<Map.Entry<Integer, Integer>> it = hashMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                debugProcessor.writer(varDebug, "record " + varCount + " : " + pair.getKey() + " => " + pair.getValue());
            }

            String varDocument = fileProcessor.replaceInFile(varInputFile, hashMap);

            if (varDocument != null && !varDocument.isEmpty())
            {
                String varCredentials = soapProcessor.getCredentials(varUsername, varPassword);
                Boolean isSSL = Boolean.parseBoolean(varUseSSL);

                debugProcessor.writer(varDebug, "connecting to URL : " + varURL);
                HttpURLConnection varConn = soapProcessor.getConnection(varCredentials, varURL, isSSL, varKeystore_LOC, varKeystore_PW);

                debugProcessor.writer(varDebug, "sending document : " + varDocument);
                String response = soapProcessor.send(varConn, varInputFile, hashMap, varDocument.getBytes());

                debugProcessor.writer(varDebug, "response received : " + response);
                if (varConn != null)
                {
                    soapProcessor.closeConnection(varConn);
                }
            }
        }
    }
}